/*
 * @(#) ResourceInfo.java 
 *
 * JOTM: Java Open Transaction Manager 
 *
 * This project is developed inside the ObjectWeb Consortium,
 * http://www.objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ResourceInfo.java,v 1.8 2003/03/24 13:13:34 jmesnil Exp $
 * --------------------------------------------------------------------------
 */
package org.objectweb.jotm;

/**
 * Information about 1 Resource logged
 */
class ResourceInfo {

    private Resource myres;
	int mystate;
	
    /**
     * Constructor 
     * called at prepare if VOTE_COMMIT
     */
    ResourceInfo(Resource res) {
        if (TraceTm.jotm.isDebugEnabled()) {
            TraceTm.jotm.debug("res=" + res);
        }
        myres = res;
        mystate = PREPARED;
    }

	Resource getResource() {
		if (TraceTm.jotm.isDebugEnabled()) {
            TraceTm.jotm.debug("res="+ myres);
        }
        return myres;		
	}
	
    // Resource state
    static final int REGISTERED = 1;
    static final int PREPARED = 2;
    static final int COMMITTED = 3;
    static final int ROLLEDBACK = 4;
    static final int HEURISTIC_COMMIT = 5;
    static final int HEURISTIC_ROLLBACK = 6;
    static final int HEURISTIC_MIXED = 7;
    static final int HEURISTIC_HAZARD = 8;
}
